﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using VMware.Vim;
using System.Collections.Specialized;
using System.Configuration; 

namespace AjpdSoftAccesoVMwareESX
{

    public partial class formAjpdSoftVMwareESX : Form
    {
        public VimClient accesoESX = new VimClient();


        public formAjpdSoftVMwareESX()
        {
            InitializeComponent();
        }

        public bool ampliarTamanoDiscoVirtual(string nombreVM, int numeroDisco, int nuevoTamanoBytes)
        {
            NameValueCollection filter = new NameValueCollection();
            filter.Add("Summary.vm", nombreVM);
            VMware.Vim.VirtualMachine vm = 
                (VMware.Vim.VirtualMachine)accesoESX.FindEntityView(typeof(VMware.Vim.VirtualMachine), 
                    null, filter, null);
            try
            {
                NameValueCollection nvc = new NameValueCollection();
                nvc.Add("name", "Datacenter");
                VMware.Vim.Datacenter dc = 
                    (VMware.Vim.Datacenter)accesoESX.FindEntityView(typeof(VMware.Vim.Datacenter), 
                        null, nvc, null);
                VirtualDiskManager vdm = new VirtualDiskManager(accesoESX, new ManagedObjectReference());
                vdm.ExtendVirtualDisk_Task(vm.Layout.Disk[numeroDisco].DiskFile[0].ToString(),
                    dc.MoRef, nuevoTamanoBytes * 1024 * 1024, false);
                return true;
            }
            catch (Exception errorC)
            {
                MessageBox.Show("Ha habido un error:" +
                    Environment.NewLine + Environment.NewLine + errorC.Message,
                    "Error",
                    MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                return false;
            }
        }

        


        private void btPowerOn_Click(object sender, EventArgs e)
        {
            string mvSel;

            if (lsMVESX.SelectedItems.Count > 0)
            {
                mvSel = lsMVESX.SelectedItems[0].Text;
                if (MessageBox.Show("¿Está seguro que desea encender la máquina virtual " +
                        mvSel + "?",  
                        "Encender máquina virtual",
                        MessageBoxButtons.YesNo, 
                        MessageBoxIcon.Question) == System.Windows.Forms.DialogResult.Yes)
                {
                    ManagedObjectReference _svcRef = new ManagedObjectReference();
                    _svcRef.Type = "ServiceInstance";
                    _svcRef.Value = "ServiceInstance";

                    try
                    {
                        NameValueCollection filterForVM = new NameValueCollection();
                        filterForVM.Add("Name", mvSel);
                        VirtualMachine vm = 
                            (VirtualMachine)accesoESX.FindEntityView(typeof(VirtualMachine), 
                                null, filterForVM, null);                        
                        vm.PowerOnVM(vm.Runtime.Host);                        
                    }
                    catch (Exception errorC)
                    {
                        MessageBox.Show("Ha habido un error:" +
                            Environment.NewLine + Environment.NewLine + errorC.Message,
                            "Error",
                            MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                    }
                }
            }
            else
                MessageBox.Show("Debe seleccionar la máquina virtual a encender.",
                    "Encender máquina virtual",
                    MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
        }

        private void formAjpdSoftVMwareESX_FormClosed(object sender, FormClosedEventArgs e)
        {
            GuardarConfiguracion proUtilidades = new GuardarConfiguracion();
            proUtilidades.guardarValorConfiguracion("URL Servidor ESX vCenter", txtURLESX.Text);
            proUtilidades.guardarValorConfiguracion("Usuario", txtUsuarioESX.Text);
            proUtilidades.guardarValorConfiguracion("Filtrar por", lsFiltrarPor.Text);
            proUtilidades.guardarValorConfiguracion("Valor filtro", lsValorFiltro.Text);

            //guardar contraseña cifrada
            cifrarAES cifradoAES = new cifrarAES();
            proUtilidades.guardarValorConfiguracion("Contraseña",
                cifradoAES.cifrarTextoAES(txtContrasenaESX.Text, "AjpdSoft_Frase_Encriptado",
                    "AjpdSoft_Frase_Encriptado", "MD5", 22, "1234567891234567", 128));
            try
            {
                //Cerramos la conexión con el servidor ESX
                accesoESX.Disconnect();
            }
            catch
            {

            }
        }

        private void btPowerOff_Click(object sender, EventArgs e)
        {
            string mvSel;

            if (lsMVESX.SelectedItems.Count > 0)
            {
                mvSel = lsMVESX.SelectedItems[0].Text;
                if (MessageBox.Show("¿Está seguro que desea apagar la máquina virtual " +
                        mvSel + "?",
                        "Apagar máquina virtual",
                        MessageBoxButtons.YesNo,
                        MessageBoxIcon.Question) == System.Windows.Forms.DialogResult.Yes)
                {
                    ManagedObjectReference _svcRef = new ManagedObjectReference();
                    _svcRef.Type = "ServiceInstance";
                    _svcRef.Value = "ServiceInstance";

                    try
                    {
                        NameValueCollection filterForVM = new NameValueCollection();
                        filterForVM.Add("Name", mvSel);
                        VirtualMachine vm =
                            (VirtualMachine)accesoESX.FindEntityView(typeof(VirtualMachine), 
                                null, filterForVM, null);
                        vm.PowerOffVM();
                    }
                    catch (Exception errorC)
                    {
                        MessageBox.Show("Ha habido un error:" +
                            Environment.NewLine + Environment.NewLine + errorC.Message,
                            "Error",
                            MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                    }
                }
            }
            else
                MessageBox.Show("Debe seleccionar la máquina virtual a apagar.",
                    "Apagar máquina virtual",
                    MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
        }

        private void btRenombrarMV_Click(object sender, EventArgs e)
        {
            string mvSel;

            if (lsMVESX.SelectedItems.Count > 0)
            {
                if (txtNombreVM.Text == "")
                {
                    MessageBox.Show("Debe indicar el nuevo nombre de la máquina virtual.",
                    "Renombrar máquina virtual",
                    MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                }
                else
                {
                    mvSel = lsMVESX.SelectedItems[0].Text;
                    if (MessageBox.Show("¿Está seguro que desea renombrar la máquina virtual [" +
                            mvSel + "] por [" + txtNombreVM.Text + "]?",
                            "Renombrar máquina virtual",
                            MessageBoxButtons.YesNo,
                            MessageBoxIcon.Question) == System.Windows.Forms.DialogResult.Yes)
                    {
                        ManagedObjectReference _svcRef = new ManagedObjectReference();
                        _svcRef.Type = "ServiceInstance";
                        _svcRef.Value = "ServiceInstance";

                        try
                        {
                            NameValueCollection filterForVM = new NameValueCollection();
                            filterForVM.Add("Name", mvSel);
                            VirtualMachine vm = 
                                (VirtualMachine)accesoESX.FindEntityView(typeof(VirtualMachine), 
                                    null, filterForVM, null);
                            VirtualMachineConfigSpec vmConfigSpec = new VirtualMachineConfigSpec();
                            vmConfigSpec.Name = txtNombreVM.Text; // Cambiar nombre a MV
                            vm.ReconfigVM_Task(vmConfigSpec);
                        }
                        catch (Exception errorC)
                        {
                            MessageBox.Show("Ha habido un error:" +
                                Environment.NewLine + Environment.NewLine + errorC.Message,
                                "Error",
                                MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                        }
                    }
                }
            }
            else
                MessageBox.Show("Debe seleccionar la máquina virtual a renombrar.",
                    "Renombrar máquina virtual",
                    MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
        }

        private void btReiniciarGuest_Click(object sender, EventArgs e)
        {
            string mvSel;

            if (lsMVESX.SelectedItems.Count > 0)
            {
                mvSel = lsMVESX.SelectedItems[0].Text;
                if (MessageBox.Show("¿Está seguro que desea reiniciar el sistema operativo " +
                        "de la máquina virtual [" + mvSel + "]?",
                        "Reiniciar sistema operativo",
                        MessageBoxButtons.YesNo,
                        MessageBoxIcon.Question) == System.Windows.Forms.DialogResult.Yes)
                {
                    ManagedObjectReference _svcRef = new ManagedObjectReference();
                    _svcRef.Type = "ServiceInstance";
                    _svcRef.Value = "ServiceInstance";

                    try
                    {
                        NameValueCollection filterForVM = new NameValueCollection();
                        filterForVM.Add("Name", mvSel);
                        VirtualMachine vm =
                            (VirtualMachine)accesoESX.FindEntityView(typeof(VirtualMachine),
                                null, filterForVM, null);
                        vm.RebootGuest();
                    }
                    catch (Exception errorC)
                    {
                        MessageBox.Show("Ha habido un error:" +
                            Environment.NewLine + Environment.NewLine + errorC.Message,
                            "Error",
                            MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                    }
                }
            }
            else
                MessageBox.Show("Debe seleccionar la máquina virtual a reiniciar.",
                    "Reiniciar máquina virtual",
                    MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
        }

        private void btExportarCSV_Click(object sender, EventArgs e)
        {
            dlGuardar.Filter = "Fichero CSV (*.csv)|*.csv";
            dlGuardar.FileName = "Máquinas virtuales ESX";
            dlGuardar.Title = "Exportar a CSV";
            if (dlGuardar.ShowDialog() == DialogResult.OK)
            {
                StringBuilder csvMemoria = new StringBuilder();
                foreach (ColumnHeader columnasLista in lsMVESX.Columns)
                {
                    csvMemoria.Append(String.Format("\"{0}\";", columnasLista.Text));
                }
                csvMemoria.AppendLine();
                foreach (ListViewItem elementosLista in lsMVESX.Items)
                {
                    foreach (ListViewItem.ListViewSubItem lvs in elementosLista.SubItems)
                    {
                        if (lvs.Text.Trim() == string.Empty)
                            csvMemoria.Append("\"\";");
                        else
                            csvMemoria.Append(String.Format("\"{0}\";", lvs.Text));
                    }
                    csvMemoria.AppendLine();
                }
                System.IO.StreamWriter sw =
                    new System.IO.StreamWriter(dlGuardar.FileName, false,
                       System.Text.Encoding.Default);
                sw.Write(csvMemoria.ToString());
                sw.Close();
            }
        }


        private void btSuspender_Click(object sender, EventArgs e)
        {
            string mvSel;

            if (lsMVESX.SelectedItems.Count > 0)
            {
                mvSel = lsMVESX.SelectedItems[0].Text;
                if (MessageBox.Show("¿Está seguro que desea suspender la " +
                        "máquina virtual [" + mvSel + "]?",
                        "Suspender MV",
                        MessageBoxButtons.YesNo,
                        MessageBoxIcon.Question) == System.Windows.Forms.DialogResult.Yes)
                {
                    ManagedObjectReference _svcRef = new ManagedObjectReference();
                    _svcRef.Type = "ServiceInstance";
                    _svcRef.Value = "ServiceInstance";

                    try
                    {
                        NameValueCollection filterForVM = new NameValueCollection();
                        filterForVM.Add("Name", mvSel);
                        VirtualMachine vm =
                            (VirtualMachine)accesoESX.FindEntityView(typeof(VirtualMachine),
                                null, filterForVM, null);
                        vm.SuspendVM();
                    }
                    catch (Exception errorC)
                    {
                        MessageBox.Show("Ha habido un error:" +
                            Environment.NewLine + Environment.NewLine + errorC.Message,
                            "Error",
                            MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                    }
                }
            }
            else
                MessageBox.Show("Debe seleccionar la máquina virtual a suspender.",
                    "Reiniciar máquina virtual",
                    MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
        }

        private void btActualizarVMwareTools_Click(object sender, EventArgs e)
        {
            string mvSel;

            if (lsMVESX.SelectedItems.Count > 0)
            {
                mvSel = lsMVESX.SelectedItems[0].Text;
                if (MessageBox.Show("¿Está seguro que desea actualizar las VMware Tools de la " +
                        "máquina virtual [" + mvSel + "]?",
                        "Actualizar VMware Tools",
                        MessageBoxButtons.YesNo,
                        MessageBoxIcon.Question) == System.Windows.Forms.DialogResult.Yes)
                {
                    ManagedObjectReference _svcRef = new ManagedObjectReference();
                    _svcRef.Type = "ServiceInstance";
                    _svcRef.Value = "ServiceInstance";

                    try
                    {
                        NameValueCollection filterForVM = new NameValueCollection();
                        filterForVM.Add("Name", mvSel);
                        VirtualMachine vm =
                            (VirtualMachine)accesoESX.FindEntityView(typeof(VirtualMachine),
                                null, filterForVM, null);
                        vm.UpgradeTools("");
                    }
                    catch (Exception errorC)
                    {
                        MessageBox.Show("Ha habido un error:" +
                            Environment.NewLine + Environment.NewLine + errorC.Message,
                            "Error",
                            MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                    }
                }
            }
            else
                MessageBox.Show("Debe seleccionar la máquina virtual a actualizar las VMware Tools.",
                    "Actualizar VMware Tools",
                    MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
        }

        private void btInstalarVMwareTools_Click(object sender, EventArgs e)
        {
            string mvSel;

            if (lsMVESX.SelectedItems.Count > 0)
            {
                mvSel = lsMVESX.SelectedItems[0].Text;
                if (MessageBox.Show("¿Está seguro que desea instalar las VMware Tools en la " +
                        "máquina virtual [" + mvSel + "]?",
                        "Instalar VMware Tools",
                        MessageBoxButtons.YesNo,
                        MessageBoxIcon.Question) == System.Windows.Forms.DialogResult.Yes)
                {
                    ManagedObjectReference _svcRef = new ManagedObjectReference();
                    _svcRef.Type = "ServiceInstance";
                    _svcRef.Value = "ServiceInstance";

                    try
                    {
                        NameValueCollection filterForVM = new NameValueCollection();
                        filterForVM.Add("Name", mvSel);
                        VirtualMachine vm =
                            (VirtualMachine)accesoESX.FindEntityView(typeof(VirtualMachine),
                                null, filterForVM, null);
                        vm.MountToolsInstaller();
                    }
                    catch (Exception errorC)
                    {
                        MessageBox.Show("Ha habido un error:" +
                            Environment.NewLine + Environment.NewLine + errorC.Message,
                            "Error",
                            MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                    }
                }
            }
            else
                MessageBox.Show("Debe seleccionar la máquina virtual para instalar las VMware Tools.",
                    "Instalar VMware Tools",
                    MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
        }

        private void btApagarSO_Click(object sender, EventArgs e)
        {
            string mvSel;

            if (lsMVESX.SelectedItems.Count > 0)
            {
                mvSel = lsMVESX.SelectedItems[0].Text;
                if (MessageBox.Show("¿Está seguro que desea apagar el sistema operativo " +
                        "de la máquina virtual [" + mvSel + "]?",
                        "Apagar sistema operativo",
                        MessageBoxButtons.YesNo,
                        MessageBoxIcon.Question) == System.Windows.Forms.DialogResult.Yes)
                {
                    ManagedObjectReference _svcRef = new ManagedObjectReference();
                    _svcRef.Type = "ServiceInstance";
                    _svcRef.Value = "ServiceInstance";

                    try
                    {
                        NameValueCollection filterForVM = new NameValueCollection();
                        filterForVM.Add("Name", mvSel);
                        VirtualMachine vm =
                            (VirtualMachine)accesoESX.FindEntityView(typeof(VirtualMachine),
                                null, filterForVM, null);
                        vm.ShutdownGuest();
                    }
                    catch (Exception errorC)
                    {
                        MessageBox.Show("Ha habido un error:" +
                            Environment.NewLine + Environment.NewLine + errorC.Message,
                            "Error",
                            MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                    }
                }
            }
            else
                MessageBox.Show("Debe seleccionar la máquina virtual a apagar el sistema operativo.",
                    "Apagar Sistema Operativo",
                    MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
        }

        private void formAjpdSoftVMwareESX_Load(object sender, EventArgs e)
        {
            //Establecemos las propiedades del ListView
            lsMVESX.View = System.Windows.Forms.View.Details;
            lsMVESX.GridLines = true;
            lsMVESX.FullRowSelect = true;

            //Añadimos las columnas al ListView
            lsMVESX.Columns.Add("MV", 130);
            lsMVESX.Columns.Add("PW Estado", 70);
            lsMVESX.Columns.Add("Tiempo inicio", 110);
            lsMVESX.Columns.Add("Estado", 70);
            lsMVESX.Columns.Add("vRAM", 60);
            lsMVESX.Columns.Add("vCPU", 60);
            lsMVESX.Columns.Add("Cores x socket", 80);
            lsMVESX.Columns.Add("Estado Tools", 100);
            lsMVESX.Columns.Add("Hostname", 80);
            lsMVESX.Columns.Add("IP", 100);
            lsMVESX.Columns.Add("SO", 150);
            lsMVESX.Columns.Add("Path", 150);
            lsMVESX.Columns.Add("ID Guest", 80);
            lsMVESX.Columns.Add("Uuid", 80);
            lsMVESX.Columns.Add("WWN", 80);
            lsMVESX.Columns.Add("Anotaciones", 80);
            lsMVESX.Columns.Add("Nº Discos MV", 50);
            lsMVESX.Columns.Add("Tamaño Discos MV", 50);
            lsMVESX.Columns.Add("Nº Discos Guest", 50);
            lsMVESX.Columns.Add("Tamaño Discos Guest", 80);
            lsMVESX.Columns.Add("Ficheros MV", 80);
            lsMVESX.Columns.Add("Alarma", 80);

            GuardarConfiguracion proUtilidades = new GuardarConfiguracion();
            txtURLESX.Text = proUtilidades.leerValorConfiguracion("URL Servidor ESX vCenter");
            txtUsuarioESX.Text = proUtilidades.leerValorConfiguracion("Usuario");
            lsFiltrarPor.Text = proUtilidades.leerValorConfiguracion("Filtrar por");
            lsValorFiltro.Text = proUtilidades.leerValorConfiguracion("Valor filtro");

            //leer contraseña cifrada
            cifrarAES cifradoAES = new cifrarAES();
            string contrasenaCifrada = "";
            contrasenaCifrada = proUtilidades.leerValorConfiguracion("Contraseña");
            txtContrasenaESX.Text =
                cifradoAES.descifrarTextoAES(contrasenaCifrada, "AjpdSoft_Frase_Encriptado",
                     "AjpdSoft_Frase_Encriptado", "MD5", 22, "1234567891234567", 128);
        }

        private void lsMVESX_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (lsMVESX.SelectedItems.Count > 0)
                txtNombreVM.Text = lsMVESX.SelectedItems[0].Text;
        }

        private void btSnapshot_Click(object sender, EventArgs e)
        {
            string mvSel;

            if (lsMVESX.SelectedItems.Count > 0)
            {
                if (txtSnapshotNombre.Text == "")
                {
                    MessageBox.Show("Debe indicar el nombre del snapshot que se creará.",
                    "Snapshot máquina virtual",
                    MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                }
                else
                {
                    mvSel = lsMVESX.SelectedItems[0].Text;
                    if (MessageBox.Show("¿Está seguro que desea crear un snapshot del momento actual para la MV [" +
                            mvSel + "]?",
                            "Snapshot máquina virtual",
                            MessageBoxButtons.YesNo,
                            MessageBoxIcon.Question) == System.Windows.Forms.DialogResult.Yes)
                    {
                        ManagedObjectReference _svcRef = new ManagedObjectReference();
                        _svcRef.Type = "ServiceInstance";
                        _svcRef.Value = "ServiceInstance";

                        try
                        {
                            NameValueCollection filterForVM = new NameValueCollection();
                            filterForVM.Add("Name", mvSel);
                            VirtualMachine vm =
                                (VirtualMachine)accesoESX.FindEntityView(typeof(VirtualMachine),
                                    null, filterForVM, null);
                            vm.CreateSnapshot(txtSnapshotNombre.Text, txtSnapshotDescripcion.Text, 
                                opSnapshotMemoria.Checked, opSnapshotQuiesceFileSystem.Checked);
                        }
                        catch (Exception errorC)
                        {
                            MessageBox.Show("Ha habido un error:" +
                                Environment.NewLine + Environment.NewLine + errorC.Message,
                                "Error",
                                MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                        }
                    }
                }
            }
            else
                MessageBox.Show("Debe seleccionar la máquina virtual a renombrar.",
                    "Renombrar máquina virtual",
                    MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
        }

        private void btDesconectarESXvCenter_Click(object sender, EventArgs e)
        {
            try
            {
                accesoESX.Disconnect();
            }
            catch (Exception errorC)
            {
                MessageBox.Show("Ha habido un error:" +
                    Environment.NewLine + Environment.NewLine + errorC.Message,
                    "Error",
                    MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
            }
        }

        private void btConectarESXvCenter_Click(object sender, EventArgs e)
        {
            if (!opLimpiarLista.Checked)
                lsMVESX.Items.Clear();

            try
            {
                // Conectamos con vSphere ESX - vCenter servicio web
                accesoESX.Connect(txtURLESX.Text);
                // Iniciamos sesión en el servidor VMware ESX - vCenter con usuario y contraseña
                accesoESX.Login(txtUsuarioESX.Text, txtContrasenaESX.Text);

                //Filtramos las máquinas virtuales (por el campo y valor que queramos)
                NameValueCollection filter = new NameValueCollection();
                if (opAplicarFiltro.Checked)
                    filter.Add(lsFiltrarPor.Text, lsValorFiltro.Text);
                IList<EntityViewBase> vmList =
                    accesoESX.FindEntityViews(typeof(VirtualMachine), null, filter, null);

                //datos de conexión a VMware ESX - vCenter
                txtInfoServerESX.Text = accesoESX.ServiceContent.About.FullName + " " +
                    accesoESX.ServiceContent.About.ApiType + " " +
                    accesoESX.ServiceContent.About.LicenseProductName + " " +
                    accesoESX.ServiceContent.About.OsType + " " +
                    accesoESX.ServiceContent.IpPoolManager + " " +
                    accesoESX.ServiceContent.About.Vendor + " " +
                    accesoESX.ServiceUrl + " " +
                    accesoESX.ServiceContent.About.DynamicProperty;

                //datos de licencia VMware ESX - vCenter
                VMware.Vim.LicenseManager licenciaESXvCenter = 
                    (VMware.Vim.LicenseManager)accesoESX.GetView(accesoESX.ServiceContent.LicenseManager, null);
                LicenseManagerLicenseInfo[] licencia = licenciaESXvCenter.Licenses;
                string tipoLicenciaESX = "";
                string claveLicenciaESX = "";
                foreach (LicenseManagerLicenseInfo lic in licencia)
                {
                    tipoLicenciaESX = lic.Name.ToString();
                    claveLicenciaESX = lic.LicenseKey.ToString();
                }
                txtLicenciaESX.Text = tipoLicenciaESX + " Key: " + claveLicenciaESX;

                //Añadimos los elementos (filas) al ListView
                string[] elementosFila = new string[22];
                ListViewItem elementoListView;
                string ficherosMV = "";

                // Recorremos todas las máquinas virtuales del ESX que cumplan el filtro
                foreach (VirtualMachine vm in vmList)
                {
                    elementosFila[0] = vm.Name;
                    elementosFila[1] = Convert.ToString(vm.Runtime.PowerState);
                    elementosFila[2] = Convert.ToString(vm.Runtime.BootTime);
                    elementosFila[3] = Convert.ToString(vm.Runtime.ConnectionState);
                    elementosFila[4] = Convert.ToString(vm.Config.Hardware.MemoryMB);
                    elementosFila[5] = Convert.ToString(vm.Config.Hardware.NumCPU);
                    elementosFila[6] = Convert.ToString(vm.Config.Hardware.NumCoresPerSocket);
                    elementosFila[7] = Convert.ToString(vm.Guest.ToolsStatus);
                    elementosFila[8] = Convert.ToString(vm.Guest.HostName);
                    elementosFila[9] = Convert.ToString(vm.Guest.IpAddress);
                    elementosFila[10] = Convert.ToString(vm.Guest.GuestFullName);
                    elementosFila[11] = Convert.ToString(vm.Config.Files.VmPathName);
                    elementosFila[12] = Convert.ToString(vm.Config.GuestId);
                    elementosFila[13] = Convert.ToString(vm.Config.Uuid);
                    elementosFila[14] = Convert.ToString(vm.Config.NpivPortWorldWideName);
                    elementosFila[15] = Convert.ToString(vm.Config.Annotation);

                    if (vm.Layout.Disk != null)
                    {
                        elementosFila[16] = Convert.ToString(vm.Layout.Disk.Count());

                        //Tamaño de los discos duros virtuales de la máquina virtual
                        long tamano = 0;
                        string discosTamano = "";
                        foreach (VirtualDevice dispositivo in vm.Config.Hardware.Device)
                        {
                            if (dispositivo.GetType() == typeof(VirtualDisk))
                            {
                                VirtualDisk disco = new VirtualDisk();
                                if (discosTamano == "")
                                    discosTamano = disco.DiskObjectId + " -> " +
                                        Convert.ToString(disco.CapacityInKB / 1024 / 1024) + "GB";
                                else
                                    discosTamano = discosTamano + " || " + disco.DiskObjectId + " -> " +
                                        Convert.ToString(disco.CapacityInKB / 1024 / 1024) + "GB";
                                tamano = tamano + disco.CapacityInKB / 1024 / 1024;
                            }
                        }
                        elementosFila[17] = Convert.ToString(tamano) + " " + discosTamano;
                        
                        ficherosMV = "";

                        //Obtener todos los ficheros que componen la máquina virtual
                        for (int i = 0; i < vm.Layout.Disk.Count(); i++)
                        {
                            for (int j = 0; j < vm.Layout.Disk[i].DiskFile.Count(); j++)
                            {
                                ficherosMV = ficherosMV + " || " + vm.Layout.Disk[i].DiskFile[j];
                            }
                        }
                        elementosFila[20] = ficherosMV;
                    }
                    else
                    {
                        elementosFila[16] = "--";
                        elementosFila[17] = "--";
                    }

                    if (vm.Guest.Disk != null)
                    {
                        elementosFila[18] = Convert.ToString(vm.Guest.Disk.Count());
                        long? tamanoDiscos = 0;
                        for (int i = 0; i < vm.Guest.Disk.Count(); i++)
                        {
                            tamanoDiscos = tamanoDiscos + vm.Guest.Disk[i].Capacity;
                        }
                        elementosFila[19] = Convert.ToString(tamanoDiscos / 1024 / 1024 / 1024);
                    }
                    else
                    {
                        elementosFila[18] = "--";
                        elementosFila[19] = "--";
                    }                   

                    //obtenemos las posibles alarmas activas para la máquina virtual
                    VMware.Vim.AlarmState[] alarmaMV = vm.TriggeredAlarmState;
                    string alarmasMV = "";
                    foreach (AlarmState alarma in alarmaMV)
                    {
                         alarmasMV = alarmasMV + alarma.Alarm.Value + " || ";
                    }
                    elementosFila[21] = alarmasMV;
                    
                    elementoListView = new ListViewItem(elementosFila);
                    lsMVESX.Items.Add(elementoListView);
                }
            }
            catch (Exception errorC)
            {
                MessageBox.Show("Ha habido un error:" +
                    Environment.NewLine + Environment.NewLine + errorC.Message,
                    "Error",
                    MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
            } 
        }

        private void btResetearMV_Click(object sender, EventArgs e)
        {
            string mvSel;

            if (lsMVESX.SelectedItems.Count > 0)
            {
                mvSel = lsMVESX.SelectedItems[0].Text;
                if (MessageBox.Show("¿Está seguro que desea resetear la " +
                        "máquina virtual [" + mvSel + "]?",
                        "Resetear MV",
                        MessageBoxButtons.YesNo,
                        MessageBoxIcon.Question) == System.Windows.Forms.DialogResult.Yes)
                {
                    ManagedObjectReference _svcRef = new ManagedObjectReference();
                    _svcRef.Type = "ServiceInstance";
                    _svcRef.Value = "ServiceInstance";

                    try
                    {
                        NameValueCollection filterForVM = new NameValueCollection();
                        filterForVM.Add("Name", mvSel);
                        VirtualMachine vm =
                            (VirtualMachine)accesoESX.FindEntityView(typeof(VirtualMachine),
                                null, filterForVM, null);
                        vm.ResetVM();
                    }
                    catch (Exception errorC)
                    {
                        MessageBox.Show("Ha habido un error:" +
                            Environment.NewLine + Environment.NewLine + errorC.Message,
                            "Error",
                            MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                    }
                }
            }
            else
                MessageBox.Show("Debe seleccionar la máquina virtual a resetear.",
                    "Resetear máquina virtual",
                    MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
        }

        private void btMontarVMwareTools_Click(object sender, EventArgs e)
        {
            string mvSel;

            if (lsMVESX.SelectedItems.Count > 0)
            {
                mvSel = lsMVESX.SelectedItems[0].Text;
                if (MessageBox.Show("¿Está seguro que desea desmontar el CD de las VMware Tools en la " +
                        "máquina virtual [" + mvSel + "]?",
                        "Desmontar CD VMware Tools",
                        MessageBoxButtons.YesNo,
                        MessageBoxIcon.Question) == System.Windows.Forms.DialogResult.Yes)
                {
                    ManagedObjectReference _svcRef = new ManagedObjectReference();
                    _svcRef.Type = "ServiceInstance";
                    _svcRef.Value = "ServiceInstance";

                    try
                    {
                        NameValueCollection filterForVM = new NameValueCollection();
                        filterForVM.Add("Name", mvSel);
                        VirtualMachine vm =
                            (VirtualMachine)accesoESX.FindEntityView(typeof(VirtualMachine),
                                null, filterForVM, null);
                        vm.UnmountToolsInstaller();
                    }
                    catch (Exception errorC)
                    {
                        MessageBox.Show("Ha habido un error:" +
                            Environment.NewLine + Environment.NewLine + errorC.Message,
                            "Error",
                            MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                    }
                }
            }
            else
                MessageBox.Show("Debe seleccionar la máquina virtual para desmontar las VMware Tools.",
                    "Desmontar VMware Tools",
                    MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
        }

        private void btObtenerUltimaTarea_Click(object sender, EventArgs e)
        {
            /*
                    
TaskHistoryCollector tareas;
TaskFilterSpec filtroTareas = new TaskFilterSpec();
filtroTareas.Time.BeginTime = DateTime.Now;                    
tareas = vm.GetAllTasksView(filtroTareas);
tareas.ReadNextTasks(1);
foreach (TaskInfo tarea in tareas)
{
    elementosFila[21] = tarea.Description.Message;
}

*/

            /*
                    ManagedObjectReference _svcRef = new ManagedObjectReference();
                    _svcRef.Type = "ServiceInstance";
                    _svcRef.Value = "ServiceInstance";

                    try
                    {
                        NameValueCollection filterForVM = new NameValueCollection();
                        filterForVM.Add("Name", mvSel);
                        VirtualMachine vm =
                            (VirtualMachine)accesoESX.FindEntityView(typeof(VirtualMachine),
                                null, filterForVM, null);
                        vm.UnmountToolsInstaller();
                    }
                    catch (Exception errorC)
                    {
                        MessageBox.Show("Ha habido un error:" +
                            Environment.NewLine + Environment.NewLine + errorC.Message,
                            "Error",
                            MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                    }
                }
            }
            else
                MessageBox.Show("Debe seleccionar la máquina virtual para desmontar las VMware Tools.",
                    "Desmontar VMware Tools",
                    MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
             */
        }    
    }
}
